#!/usr/bin/perl
#################################################################
#FILE: hfparser.pm
#HTML FORM PARSING MODULE
#Copyright  by UrsaloFF 
#################################################################
package hfparser;
use dparser;
use CGI;
use Carp;
$q = new CGI;
@ISA=("dparser");
$VERSION='1.2';
###   -  CSS   
$def_class="INPUTmy";
$def_over_class="INPUTmyACT";
$def_error_class="INPUTmyERR";

#############################################
sub _init{
 my $self=shift;
 ###DEFAULT###
    $self->_set_defaults;
 ###INIT_DATA - OVERVRITE DEFAULTS
 if (@_){
       my %extra= @_;
        foreach (keys %extra){
           $self->{$_}=$extra{$_};
        }
  }
  $self->_set_defaults_errors;
 #####LOAD DATA FROM SOURCE
  $self->_load_data;
 }
sub _set_defaults_errors{
 my $self=shift;
 $self->{ERROR_HEADER}="<DIV class=\"ERROR_HEADER\">Error(s) detected:</DIV>" unless ($self->{ERROR_HEADER}) ;
 $self->{ERROR_AFTER_TEMPL}="<BR><SPAN class=\"ERROR_ELEMENT\">###ERR###</SPAN>" unless ($self->{ERROR_AFTER_TEMPL});
 if ($self->{ERROR_AFTER_INPUT} eq '0'){
      $self->{ERROR_TEMPL_BEFOR}="<FONT color=red><UL>" unless ($self->{ERROR_TEMPL_BEFOR});
      $self->{ERROR_TEMPL}="<LI>###ERR###</LI>" unless ($self->{ERROR_TEMPL});
      $self->{ERROR_TEMPL_AFTER}="</UL></FONT>" unless ($self->{ERROR_TEMPL_AFTER});
 }

 }
######
sub _crosshesh{
  my $self = shift;
  my $first_ref=shift;
  my $default_ref=shift;
  my %first=%{$first_ref};
  my %default=%{$default_ref};
  foreach my $key(keys %default){
     $first{$key}=$default{$key} unless exists($first{$key});
  }

 return  %first;
}

sub set_default_input{
$_[0]->{INPUT_DEF}{$_[1]}{$_[2]}=$_[3];
}
######
sub _set_defaults{
 my $self=shift;
 my  $pars_ref=\&ParseString;
 $self->add_parsing($pars_ref);
 $self->add_func('{error}',\&printerror,$self);
 ###DEFAULTS FOR DATAPARSER
 $self->{SOURCE}='file';
 $self->{STRING_DELMITTER}="\r\n";
 ###DEFAULTS FOR FORMPARSER
 $self->{INPUT_DEF}{"text"}{"size"}=15;
 $self->{INPUT_DEF}{"text"}{"maxlength"}=80;
 $self->{INPUT_DEF}{"text"}{"class"}=$def_class;
 $self->{INPUT_DEF}{"text"}{"on_err_class"}=$def_error_class;
 $self->{INPUT_DEF}{"text"}{"onFocus"}="this.className ='$def_over_class' ;";
 $self->{INPUT_DEF}{"text"}{"onBlur"}=" this.className ='$def_class' ;";
 #### TEXTAREA
  $self->{INPUT_DEF}{"textarea"}{"rows"}=10;
  $self->{INPUT_DEF}{"textarea"}{"columns"}=40;
  $self->{INPUT_DEF}{"textarea"}{"class"}=$def_class;
  $self->{INPUT_DEF}{"textarea"}{"on_err_class"}=$def_error_class;
  $self->{INPUT_DEF}{"textarea"}{"onFocus"}="this.className ='$def_over_class' ;";
  $self->{INPUT_DEF}{"textarea"}{"onBlur"}=" this.className ='$def_class' ;";
  #### SELECT
  $self->{INPUT_DEF}{"select"}{"class"}=$def_class;
  $self->{INPUT_DEF}{"select"}{"onFocus"}="this.className ='$def_over_class' ; return true;";
  $self->{INPUT_DEF}{"select"}{"onBlur"}=" this.className ='$def_class' ; return true;";
  $self->{INPUT_DEF}{"select"}{"on_err_class"}=$def_error_class;
  ## LIST
  $self->{INPUT_DEF}{"list"}{"onFocus"}="this.className ='$def_over_class' ; return true;";
  $self->{INPUT_DEF}{"list"}{"onBlur"}=" this.className ='$def_class' ; return true;";
  $self->{INPUT_DEF}{"list"}{"multiple"}="true";
  $self->{INPUT_DEF}{"list"}{"size"}=4;
  $self->{INPUT_DEF}{"list"}{"class"}=$def_class;
  ## CHECKBOX
  $self->{INPUT_DEF}{"check"}{"label"}=" ";
  ## RADIO
  $self->{INPUT_DEF}{"radio"}{"linebreak"}="true";
  ###      
 #         
 $self->{ERROR_AFTER_INPUT}=1;
}
######
sub printerror{
    my $self = shift;
    my $out;
    return unless $self->is_error;
#    return unless ($self->{ERROR});
    if ($self->{ERROR_AFTER_INPUT} eq '0'){
       $out.=$self->{ERROR_HEADER};
     #    
       $out.=$self->{ERROR_TEMPL_BEFOR}."\n";
       my %error=%{$self->{ERROR}};
       foreach my $n (keys %error){
              my $templ=$self->{ERROR_TEMPL};
              $templ=~s/###ERR###/$self->{ERROR}{$n}/;
              $out.=$templ."\n" if ($self->{ERROR}{$n} ne ' ');
       }
       $out.=$self->{ERROR_TEMPL_AFTER}."\n";
    }else{
    #  
    $out.=$self->{ERROR_HEADER};
    }
    return $out;
}
###########################
sub processTEXT{
my $self = shift;
my $type = shift;
my $name = shift;
my $out;
  my %params=$self->_crosshesh($self->{INPUT}{$name},$self->{INPUT_DEF}{text});
  my $errclass;
  ####    .
  if ($params{on_err_class}){
        $errclass=$params{on_err_class};
        delete($params{on_err_class});
  }
  $params{default}=$self->{DEFAULT}{$name} if exists($self->{DEFAULT}{$name});
  $params{class}=$errclass if $self->{ERROR}{$name};
  $params{name}=$name;
  $out.=$q->textfield(\%params) if ($type eq 'text');
  $out.=$q->password_field(\%params) if ($type eq 'password');
return $out;
}
###########################
sub processTEXTAREA{
my $self = shift;
my $name = shift;
my $out;
  my %params=$self->_crosshesh($self->{INPUT}{$name},$self->{INPUT_DEF}{textarea});
  my $errclass;
  ####    .
  if ($params{on_err_class}){
        $errclass=$params{on_err_class};
        delete($params{on_err_class});
  }
  $params{default}=$self->{DEFAULT}{$name} if exists($self->{DEFAULT}{$name});
  $params{class}=$errclass if $self->{ERROR}{$name};
  $params{name}=$name;
  $out.=$q->textarea(\%params);
return $out;
}
###########################
sub processSELECT{
my $self = shift;
my $name = shift;
my $out;
  my %params=$self->_crosshesh($self->{INPUT}{$name},$self->{INPUT_DEF}{select});
  my $errclass;
  ####    .
  if ($params{on_err_class}){
        $errclass=$params{on_err_class};
	delete($params{on_err_class});
  }
   $params{default}=$self->{DEFAULT}{$name} if exists($self->{DEFAULT}{$name});
  $params{class}=$errclass if $self->{ERROR}{$name};
  $params{name}=$name;
  $out.=$q->popup_menu(\%params);
return $out;
}
###########################
sub processCHECK{
my $self = shift;
my $name = shift;
my $out;
  my %params=$self->_crosshesh($self->{INPUT}{$name},$self->{INPUT_DEF}{check});
  my $errclass;
  ####    .
  if ($params{on_err_class}){
        $errclass=$params{on_err_class};
	delete($params{on_err_class});
  }
  if (exists($self->{DEFAULT}{$name})){	
  	$params{selected}='on' if ($self->{DEFAULT}{$name});
  }
$params{class}=$errclass if $self->{ERROR}{$name};
$params{name}=$name;
$out.=$q->checkbox(\%params);
return $out;
}
###########################
sub processRADIO{
my $self = shift;
my $name = shift;
my $out;
  my %params=$self->_crosshesh($self->{INPUT}{$name},$self->{INPUT_DEF}{radio});
  my $errclass;
  ####    .
  if ($params{on_err_class}){
        $errclass=$params{on_err_class};
        delete($params{on_err_class});
  }
  $params{class}=$errclass if $self->{ERROR}{$name};
  $params{name}=$name;
  $params{default}=$self->{DEFAULT}{$name} if exists($self->{DEFAULT}{$name});
  $out.=$q->radio_group(\%params);
return $out;
}

###########################
sub processLIST{
my $self = shift;
my $name = shift;
my $out;
  my %params=$self->_crosshesh($self->{INPUT}{$name},$self->{INPUT_DEF}{list});
  my $errclass;
  ####    .
  if ($params{on_err_class}){
        $errclass=$params{on_err_class};
        delete($params{on_err_class});
  }
  $params{default}=$self->{DEFAULT}{$name} if exists($self->{DEFAULT}{$name});
  $params{class}=$errclass if $self->{ERROR}{$name};
  $params{name}=$name;
  $out.=$q->scrolling_list(\%params);
return $out;
}
###########################
sub processHIDDEN{
my $self = shift;
my $name = shift;
my $out;
my %params=$self->_crosshesh($self->{INPUT}{$name},$self->{INPUT_DEF}{hidden});
$params{default}=$self->{DEFAULT}{$name} if exists($self->{DEFAULT}{$name});
$params{name}=$name;
$out.=$q->hidden(\%params);
$out=~s/\/>$/>/;
return $out;
}
##########
sub ProcessElement{
 my $self=shift;
 my $type=shift;
 my $name=shift;
 my $out;
 if ($type eq 'text' || $type eq 'password'){
    $out=$self->processTEXT($type,$name);
 }elsif($type eq 'textarea'){
  $out=$self->processTEXTAREA($name);
 }elsif($type eq 'select'){
  $out=$self->processSELECT($name);
 }elsif($type eq 'hidden'){
  $out=$self->processHIDDEN($name);
 }elsif($type eq 'list'){
  $out=$self->processLIST($name);
 }elsif($type eq 'check'){
  $out=$self->processCHECK($name);
 }elsif($type eq 'radio'){
 $out=$self->processRADIO($name);
 }
  if ($self->{ERROR_AFTER_INPUT}){
     if (($self->{ERROR}{$name}) ){
       if($self->{ERROR}{$name} ne " "){
	my $templ=$self->{ERROR_AFTER_TEMPL};
       $templ=~s/###ERR###/$self->{ERROR}{$name}/;
       $out.=$templ;
       }
     }
   }


return $out;
}

###
sub set_def{
my $self=shift;
my $name=shift;
my $val=shift;
 $self->{DEFAULT}{$name}=$val;
}
####
sub set_input{
	my $self=shift;
	my $name=shift;
	my $h_val=shift;
	my %val=%$h_val;
	foreach (keys %val){
		$self->{INPUT}{$name}{$_}=$val{$_}
	}
}
#####
sub add_element{
my $self=shift;
my $name=shift;
my $value=shift;
my $discr=shift;
$discr=$value unless $discr;
push @{$self->{INPUT}{$name}{'values'}}, $value;
$self->{INPUT}{$name}{'labels'}{$value}=$discr;
}
#####
sub set_error{
my $self=shift;
my $name=shift;
my $err=shift;
 $self->{ERROR}{$name}=$err;
}
#####
sub is_error{
my $self = shift;
my %errors=%{$self->{ERROR}};
my $count=keys %errors;
return $count;
}
######
sub ParseString{
 my $self=shift;
 #internal function to use in {PARSING}
 my $string=$_;
 $string=~s#\{fm_([a-zA-Z]+)_([^}]+)\}#$self->ProcessElement($1,$2)#eg;
 $_=$string;
}
1;



